<?php
lt_include(PLOG_CLASS_PATH."class/action/admin/adminaction.class.php");
lt_include(PLOG_CLASS_PATH."plugins/minislideshow/class/view/pluginminislideshowconfigview.class.php");

/**
 * This class is responsible for updating the minislideshow plugin settings.
 *
 * @version 0.1
 * @author twu2
 */
class PluginMinislideshowUpdateConfigAction extends AdminAction
{
    var $_pluginEnabled;
    var $_blockTitle;
    var $_xmlUrl;
    var $_noFlashUrl;
    var $_jsUrl;
    var $_swfUrl;
    var $_shuffle;
    var $_showDropShadow;
    var $_delay;
    var $_transInType;
    var $_transOutType;
    var $_noLink;
    var $_showTitle;
    var $_titleColor;
    var $_titleBgColor;
    var $_Masks;
    var $_useFull;
    var $_fullscreenIcon;
    var $_showControls;
    var $_autoStart;
    var $_loop;
    var $_preload;
    var $_siteInfoText;
    var $_siteInfoUrl;
    var $_allowScaling;
    var $_showLoader;
    var $_mp3Url;
    var $_customLink;
    var $_linkToParent;
    var $_useResize;
    var $_fontScale;
    var $_flash_height;
    var $_flash_width;
    var $_flash_wmode;
    var $_flash_align;
    var $_flash_salign;
    var $_flash_scale;
    var $_flash_quality;
    var $_flash_menu;
    var $_flash_loop;
    var $_flash_play;
    var $_flash_allowFullScreen;

    function PluginMinislideshowUpdateConfigAction($actionInfo, $request)
    {
        $this->AdminAction($actionInfo, $request);
    }

    function validate()
    {
        $this->_pluginEnabled = $this->_request->getValue("pluginEnabled");
        $this->_pluginEnabled = ($this->_pluginEnabled != "");

        $this->_blockTitle = $this->_request->getValue("blockTitle");
        $this->_xmlUrl = $this->_request->getValue("xmlUrl");
        $this->_noFlashUrl = $this->_request->getValue("noFlashUrl");
        $this->_jsUrl = $this->_request->getValue("jsUrl");
        $this->_swfUrl = $this->_request->getValue("swfUrl");
        $this->_shuffle = $this->_request->getValue("shuffle");
        $this->_shuffle = ($this->_shuffle != "");
        $this->_showDropShadow = $this->_request->getValue("showDropShadow");
        $this->_showDropShadow = ($this->_showDropShadow != "");
        $this->_delay = $this->_request->getValue("delay");
        if (!is_numeric($this->_delay) || $this->_delay < 1)
            $this->_delay = 3;
        $this->_transInType = $this->_request->getValue("transInType");
        $this->_transOutType = $this->_request->getValue("transOutType");
        $this->_noLink = $this->_request->getValue("noLink");
        $this->_noLink = ($this->_noLink != "");
        $this->_showTitle = $this->_request->getValue("showTitle");
        $this->_titleColor = $this->_request->getValue("titleColor");
        $this->_titleBgColor = $this->_request->getValue("titleBgColor");
        $this->_Masks = $this->_request->getValue("Masks");
        $this->_useFull = $this->_request->getValue("useFull");
        $this->_useFull = ($this->_useFull != "");
        $this->_fullscreenIcon = $this->_request->getValue("fullscreenIcon");
        $this->_fullscreenIcon = ($this->_fullscreenIcon != "");
        $this->_showControls = $this->_request->getValue("showControls");
        $this->_autoStart = $this->_request->getValue("autoStart");
        $this->_autoStart = ($this->_autoStart != "");
        $this->_loop = $this->_request->getValue("loop");
        $this->_loop = ($this->_loop != "");
        $this->_preload = $this->_request->getValue("preload");
        if (!is_numeric($this->_preload) || $this->_preload < 0)
            $this->_preload = 4;
        $this->_siteInfoText = $this->_request->getValue("siteInfoText");
        $this->_siteInfoUrl = $this->_request->getValue("siteInfoUrl");
        $this->_allowScaling = $this->_request->getValue("allowScaling");
        $this->_allowScaling = ($this->_allowScaling != "");
        $this->_showLoader = $this->_request->getValue("showLoader");
        $this->_showLoader = ($this->_showLoader != "");
        $this->_mp3Url = $this->_request->getValue("mp3Url");
        $this->_customLink = $this->_request->getValue("customLink");
        $this->_linkToParent = $this->_request->getValue("linkToParent");
        $this->_linkToParent = ($this->_linkToParent != "");
        $this->_useResize = $this->_request->getValue("useResize");
        $this->_useResize = ($this->_useResize != "");
        $this->_fontScale = $this->_request->getValue("fontScale");

        $this->_flash_height = $this->_request->getValue("flash_height");
        if (!is_numeric($this->_flash_height) || $this->_flash_height < 50)
            $this->_flash_height = 50;
        $this->_flash_width = $this->_request->getValue("flash_width");
        if (!is_numeric($this->_flash_width) || $this->_flash_width < 50)
            $this->_flash_width = 50;
        $this->_flash_wmode = $this->_request->getValue("flash_wmode");
        $this->_flash_align = $this->_request->getValue("flash_align");
        $this->_flash_salign = $this->_request->getValue("flash_salign");
        $this->_flash_scale = $this->_request->getValue("flash_scale");
        $this->_flash_quality = $this->_request->getValue("flash_quality");
        $this->_flash_menu = $this->_request->getValue("flash_menu");
        $this->_flash_loop = $this->_request->getValue("flash_loop");
        $this->_flash_play = $this->_request->getValue("flash_play");
        $this->_flash_allowFullScreen = $this->_request->getValue("flash_allowFullScreen");

        if ($this->_xmlUrl == "" || $this->_swfUrl == "") {
            $this->_view = new PluginMinislideshowConfigView($this->_blogInfo);
            $this->_view->setErrorMessage($this->_locale->tr("error_required_missing"));
            $this->setCommonData();
            return false;
        }

        return true;
    }

    function perform()
    {
        $blogSettings = $this->_blogInfo->getSettings();

        // Update the relevant values with the form inputs
        $blogSettings->setValue("plugin_minislideshow_enabled", $this->_pluginEnabled);
        $blogSettings->setValue("minislideshow_block_title", $this->_blockTitle);

        // variable for minislideshow
        $blogSettings->setValue("minislideshow_xmlUrl", $this->_xmlUrl);
        $blogSettings->setValue("minislideshow_noFlashUrl", $this->_noFlashUrl);
        $blogSettings->setValue("minislideshow_jsUrl", $this->_jsUrl);
        $blogSettings->setValue("minislideshow_swfUrl", $this->_swfUrl);
        $blogSettings->setValue("minislideshow_shuffle", $this->_shuffle);
        $blogSettings->setValue("minislideshow_showDropShadow", $this->_showDropShadow);
        $blogSettings->setValue("minislideshow_delay", $this->_delay);
        $blogSettings->setValue("minislideshow_transInType", $this->_transInType);
        $blogSettings->setValue("minislideshow_transOutType", $this->_transOutType);
        $blogSettings->setValue("minislideshow_noLink", $this->_noLink);
        $blogSettings->setValue("minislideshow_showTitle", $this->_showTitle);
        $blogSettings->setValue("minislideshow_titleColor", $this->_titleColor);
        $blogSettings->setValue("minislideshow_bgColor", $this->_titleBgColor);
        $blogSettings->setValue("minislideshow_Masks", $this->_Masks);
        $blogSettings->setValue("minislideshow_useFull", $this->_useFull);
        $blogSettings->setValue("minislideshow_fullscreenIcon", $this->_fullscreenIcon);
        $blogSettings->setValue("minislideshow_showControls", $this->_showControls);
        $blogSettings->setValue("minislideshow_autoStart", $this->_autoStart);
        $blogSettings->setValue("minislideshow_loop", $this->_loop);
        $blogSettings->setValue("minislideshow_preload", $this->_preload);
        $blogSettings->setValue("minislideshow_siteInfoText", $this->_siteInfoText);
        $blogSettings->setValue("minislideshow_siteInfoUrl", $this->_siteInfoUrl);
        $blogSettings->setValue("minislideshow_allowScaling", $this->_allowScaling);
        $blogSettings->setValue("minislideshow_showLoader", $this->_showLoader);
        $blogSettings->setValue("minislideshow_mp3Url", $this->_mp3Url);
        $blogSettings->setValue("minislideshow_customLink", $this->_customLink);
        $blogSettings->setValue("minislideshow_linkToParent", $this->_linkToParent);
        $blogSettings->setValue("minislideshow_useResize", $this->_useResize);
        $blogSettings->setValue("minislideshow_fontScale", $this->_fontScale);

        // variable for flash
        $blogSettings->setValue("minislideshow_flash_height", $this->_flash_height);
        $blogSettings->setValue("minislideshow_flash_width", $this->_flash_width);
        $blogSettings->setValue("minislideshow_flash_wmode", $this->_flash_wmode);
        $blogSettings->setValue("minislideshow_flash_align", $this->_flash_align);
        $blogSettings->setValue("minislideshow_flash_salign", $this->_flash_salign);
        $blogSettings->setValue("minislideshow_flash_scale", $this->_flash_scale);
        $blogSettings->setValue("minislideshow_flash_quality", $this->_flash_quality);
        $blogSettings->setValue("minislideshow_flash_menu", $this->_flash_menu);
        $blogSettings->setValue("minislideshow_flash_loop", $this->_flash_loop);
        $blogSettings->setValue("minislideshow_flash_play", $this->_flash_play);
        $blogSettings->setValue("minislideshow_flash_allowFullScreen", $this->_flash_allowFullScreen);

        // Set and save the new blog settings
        $this->_blogInfo->setSettings($blogSettings);
        $blogs = new Blogs();

        // Display an error message if there was a problem with the update
        if(!$blogs->updateBlog($this->_blogInfo)) {
            $this->_view = new PluginMinislideshowConfigView($this->_blogInfo);
            $this->_view->setErrorMessage($this->_locale->tr("error_updating_settings"));
            $this->setCommonData();
            return false;
        }

        // If things went well, save the session...
        $this->_blogInfo->setSettings($blogSettings);
        $this->_session->setValue("blogInfo", $this->_blogInfo);
        $this->saveSession();

        // and show the success message
        $this->_view = new PluginMinislideshowConfigView($this->_blogInfo);
        $this->_view->setSuccessMessage($this->_locale->tr("minislideshow_settings_saved_ok"));
        $this->setCommonData();

        // clear the cache
        CacheControl::resetBlogCache($this->_blogInfo->getId());

        return true;
    }
}
?>
