<?php
lt_include(PLOG_CLASS_PATH."class/view/admin/adminplugintemplatedview.class.php");

/**
 * Implements the config view for the minislideshow plugin
 *
 * @version 0.1
 * @author twu2
 */
class PluginMinislideshowConfigView extends AdminPluginTemplatedView
{
    function PluginMinislideshowConfigView($blogInfo)
    {
        $this->AdminPluginTemplatedView($blogInfo, "minislideshow", "minislideshowAdmin");
    }

    function render()
    {
        // Get the current minislideshow plugin settings
        $blogSettings = $this->_blogInfo->getSettings();

        $pluginEnabled = $blogSettings->getValue("plugin_minislideshow_enabled");
        if ($pluginEnabled == '') $pluginEnabled = 0;
        $blockTitle = $blogSettings->getValue("minislideshow_block_title");

        // variable for minislideshow
        $noFlashUrl = $blogSettings->getValue("minislideshow_noFlashUrl");
        $xmlUrl = $blogSettings->getValue("minislideshow_xmlUrl");
        $jsUrl = $blogSettings->getValue("minislideshow_jsUrl");
        $swfUrl = $blogSettings->getValue("minislideshow_swfUrl");
        $shuffle = $blogSettings->getValue("minislideshow_shuffle");
        if (is_null($shuffle) || $shuffle === '') $shuffle = 0;
        $showDropShadow = $blogSettings->getValue("minislideshow_showDropShadow");
        if (is_null($showDropShadow) || $showDropShadow === '') $showDropShadow = 0;
        $delay = $blogSettings->getValue("minislideshow_delay");
        if (is_null($delay) || $delay === '') $delay = 3;
        $transInType = $blogSettings->getValue("minislideshow_transInType");
        if (is_null($transInType) || $transInType === '') $transInType = 'Fade';
        $transOutType = $blogSettings->getValue("minislideshow_transOutType");
        if (is_null($transOutType) || $transOutType === '') $transOutType = 'Fade';
        $noLink = $blogSettings->getValue("minislideshow_noLink");
        if (is_null($noLink) || $noLink === '') $noLink = 0;
        $showTitle = $blogSettings->getValue("minislideshow_showTitle");
        if (is_null($showTitle) || $showTitle === '') $showTitle = 'false';
        $titleColor = $blogSettings->getValue("minislideshow_titleColor");
        $titleBgColor = $blogSettings->getValue("minislideshow_bgColor");
        $Masks = $blogSettings->getValue("minislideshow_Masks");
        if (is_null($Masks) || $Masks === '') $Masks = 'Choose..';
        $useFull = $blogSettings->getValue("minislideshow_useFull");
        if (is_null($useFull) || $useFull === '') $useFull = 0;
        $fullscreenIcon = $blogSettings->getValue("minislideshow_fullscreenIcon");
        if (is_null($fullscreenIcon) || $fullscreenIcon === '') $fullscreenIcon = 0;
        $showControls = $blogSettings->getValue("minislideshow_showControls");
        if (is_null($showControls) || $showControls === '') $showControls = 'autohide';
        $autoStart = $blogSettings->getValue("minislideshow_autoStart");
        if (is_null($autoStart) || $autoStart === '') $autoStart = 1;
        $loop = $blogSettings->getValue("minislideshow_loop");
        if (is_null($loop) || $loop === '') $loop = 1;
        $preload = $blogSettings->getValue("minislideshow_preload");
        if (is_null($preload) || $preload === '') $preload = 4;
        $siteInfoText = $blogSettings->getValue("minislideshow_siteInfoText");
        $siteInfoUrl = $blogSettings->getValue("minislideshow_siteInfoUrl");
        $allowScaling = $blogSettings->getValue("minislideshow_allowScaling");
        if (is_null($allowScaling) || $allowScaling === '') $allowScaling = 0;
        $showLoader = $blogSettings->getValue("minislideshow_showLoader");
        if (is_null($showLoader) || $showLoader === '') $showLoader = 1;
        $mp3Url = $blogSettings->getValue("minislideshow_mp3Url");
        $customLink = $blogSettings->getValue("minislideshow_customLink");
        $linkToParent = $blogSettings->getValue("minislideshow_linkToParent");
        if (is_null($linkToParent) || $linkToParent === '') $linkToParent = 0;
        $useResize = $blogSettings->getValue("minislideshow_useResize");
        if (is_null($useResize) || $useResize === '') $useResize = 0;
        $fontScale = $blogSettings->getValue("minislideshow_fontScale");
        if (is_null($fontScale) || $fontScale === '') $fontScale = 20;

        // variable for flash
        $flash_height = $blogSettings->getValue("minislideshow_flash_height");
        if (is_null($flash_height) || $flash_height === '') $flash_height = 200;
        $flash_width = $blogSettings->getValue("minislideshow_flash_width");
        if (is_null($flash_width) || $flash_width === '') $flash_width = 200;
        $flash_wmode = $blogSettings->getValue("minislideshow_flash_wmode");
        if (is_null($flash_wmode) || $flash_wmode === '') $flash_wmode = 'Choose..';
        $flash_align = $blogSettings->getValue("minislideshow_flash_align");
        if (is_null($flash_align) || $flash_align === '') $flash_align = 'Choose..';
        $flash_salign = $blogSettings->getValue("minislideshow_flash_salign");
        if (is_null($flash_salign) || $flash_salign === '') $flash_salign = 'Choose..';
        $flash_scale = $blogSettings->getValue("minislideshow_flash_scale");
        if (is_null($flash_scale) || $flash_scale === '') $flash_scale = 'Choose..';
        $flash_quality = $blogSettings->getValue("minislideshow_flash_quality");
        if (is_null($flash_quality) || $flash_quality === '') $flash_quality = 'Choose..';
        $flash_menu = $blogSettings->getValue("minislideshow_flash_menu");
        if (is_null($flash_menu) || $flash_menu === '') $flash_menu = 'Choose..';
        $flash_loop = $blogSettings->getValue("minislideshow_flash_loop");
        if (is_null($flash_loop) || $flash_loop === '') $flash_loop = 'Choose..';
        $flash_play = $blogSettings->getValue("minislideshow_flash_play");
        if (is_null($flash_play) || $flash_play === '') $flash_play = 'Choose..';
        $flash_allowFullScreen = $blogSettings->getValue("minislideshow_flash_allowFullScreen");
        if (is_null($flash_allowFullScreen) || $flash_allowFullScreen === '') $flash_allowFullScreen = 'Choose..';
        // this should be 'always'
        //$flash_allowScriptAccess = $blogSettings->getValue("minislideshow_flash_allowScriptAccess");

        // Export the settings to the template
        $this->setValue("pluginEnabled", $pluginEnabled);
        $this->setValue("blockTitle", $blockTitle);
        $this->setValue("noFlashUrl", $noFlashUrl);
        $this->setValue("xmlUrl", $xmlUrl);
        $this->setValue("jsUrl", $jsUrl);
        $this->setValue("swfUrl", $swfUrl);
        $this->setValue("shuffle", $shuffle);
        $this->setValue("showDropShadow", $showDropShadow);
        $this->setValue("delay", $delay);
        $transitionType = array('Blinds', 'Fade', 'Fly', 'Iris', 'Photo', 'PixelDissolve', 'Rotate', 'Squeeze', 'Wipe', 'Zoom', 'Random');
        $opt = '';
        foreach ($transitionType as $value) {
            if ($transInType == $value)
                $opt .= "<option selected=\"selected\" value=\"$value\">$value</option>\n";
            else
                $opt .= "<option value=\"$value\">$value</option>\n";
        }
        $this->setValue("transInType", $opt);
        $opt = '';
        foreach ($transitionType as $value) {
            if ($transOutType == $value)
                $opt .= "<option selected=\"selected\" value=\"$value\">$value</option>\n";
            else
                $opt .= "<option value=\"$value\">$value</option>\n";
        }
        $this->setValue("transOutType", $opt);
        $this->setValue("noLink", $noLink);
        $type = array('top', 'bottom', 'false');
        $opt = '';
        foreach ($type as $value) {
            if ($showTitle == $value)
                $opt .= "<option selected=\"selected\" value=\"$value\">$value</option>\n";
            else
                $opt .= "<option value=\"$value\">$value</option>\n";
        }
        $this->setValue("showTitle", $opt);
        $this->setValue("titleColor", $titleColor);
        $this->setValue("titleBgColor", $titleBgColor);
        $maskType = array('Choose..', 'circleMask', 'roundedMask', 'starMask');
        $opt = '';
        foreach ($maskType as $value) {
            if ($Masks == $value)
                $opt .= "<option selected=\"selected\" value=\"$value\">$value</option>\n";
            else
                $opt .= "<option value=\"$value\">$value</option>\n";
        }
        $this->setValue("Masks", $opt);
        $this->setValue("useFull", $useFull);
        $this->setValue("fullscreenIcon", $fullscreenIcon);
        $showControlsType = array('autohide', 'false', 'always');
        $opt = '';
        foreach ($showControlsType as $value) {
            if ($showControls == $value)
                $opt .= "<option selected=\"selected\" value=\"$value\">$value</option>\n";
            else
                $opt .= "<option value=\"$value\">$value</option>\n";
        }
        $this->setValue("showControls", $opt);
        $this->setValue("autoStart", $autoStart);
        $this->setValue("loop", $loop);
        $this->setValue("preload", $preload);
        $this->setValue("siteInfoText", $siteInfoText);
        $this->setValue("siteInfoUrl", $siteInfoUrl);
        $this->setValue("allowScaling", $allowScaling);
        $this->setValue("showLoader", $showLoader);
        $this->setValue("mp3Url", $mp3Url);
        $this->setValue("customLink", $customLink);
        $this->setValue("linkToParent", $linkToParent);
        $this->setValue("useResize", $useResize);
        $this->setValue("fontScale", $fontScale);

        // flash parameter
        $this->setValue("flash_height", $flash_height);
        $this->setValue("flash_width", $flash_width);
        $type = array('Choose..', 'window', 'direct', 'opaque', 'transparent', 'gpu');
        $opt = '';
        foreach ($type as $value) {
            if ($flash_wmode == $value)
                $opt .= "<option selected=\"selected\" value=\"$value\">$value</option>\n";
            else
                $opt .= "<option value=\"$value\">$value</option>\n";
        }
        $this->setValue("flash_wmode", $opt);
        $type = array('Choose..', 'middle', 'left', 'right', 'top', 'bottom');
        $opt = '';
        foreach ($type as $value) {
            if ($flash_align == $value)
                $opt .= "<option selected=\"selected\" value=\"$value\">$value</option>\n";
            else
                $opt .= "<option value=\"$value\">$value</option>\n";
        }
        $this->setValue("flash_align", $opt);
        $type = array('Choose..', 'l', 't', 'r', 'b', 'tl', 'tr', 'bl', 'br');
        $opt = '';
        foreach ($type as $value) {
            if ($flash_salign == $value)
                $opt .= "<option selected=\"selected\" value=\"$value\">$value</option>\n";
            else
                $opt .= "<option value=\"$value\">$value</option>\n";
        }
        $this->setValue("flash_salign", $opt);
        $type = array('Choose..', 'default', 'noborder', 'exactfit', 'noscale');
        $opt = '';
        foreach ($type as $value) {
            if ($flash_scale == $value)
                $opt .= "<option selected=\"selected\" value=\"$value\">$value</option>\n";
            else
                $opt .= "<option value=\"$value\">$value</option>\n";
        }
        $this->setValue("flash_scale", $opt);
        $type = array('Choose..', 'low', 'autolow', 'autohigh', 'medium', 'high', 'best');
        $opt = '';
        foreach ($type as $value) {
            if ($flash_quality == $value)
                $opt .= "<option selected=\"selected\" value=\"$value\">$value</option>\n";
            else
                $opt .= "<option value=\"$value\">$value</option>\n";
        }
        $this->setValue("flash_quality", $opt);
        $type = array('Choose..', 'true', 'false');
        $opt = '';
        foreach ($type as $value) {
            if ($flash_menu == $value)
                $opt .= "<option selected=\"selected\" value=\"$value\">$value</option>\n";
            else
                $opt .= "<option value=\"$value\">$value</option>\n";
        }
        $this->setValue("flash_menu", $opt);
        $type = array('Choose..', 'true', 'false');
        $opt = '';
        foreach ($type as $value) {
            if ($flash_loop == $value)
                $opt .= "<option selected=\"selected\" value=\"$value\">$value</option>\n";
            else
                $opt .= "<option value=\"$value\">$value</option>\n";
        }
        $this->setValue("flash_loop", $opt);
        $type = array('Choose..', 'true', 'false');
        $opt = '';
        foreach ($type as $value) {
            if ($flash_play == $value)
                $opt .= "<option selected=\"selected\" value=\"$value\">$value</option>\n";
            else
                $opt .= "<option value=\"$value\">$value</option>\n";
        }
        $this->setValue("flash_play", $opt);
        $type = array('Choose..', 'true', 'false');
        $opt = '';
        foreach ($type as $value) {
            if ($flash_allowFullScreen == $value)
                $opt .= "<option selected=\"selected\" value=\"$value\">$value</option>\n";
            else
                $opt .= "<option value=\"$value\">$value</option>\n";
        }
        $this->setValue("flash_allowFullScreen", $opt);

        parent::render();

        return true;
    }
}
?>
